<?xml version="1.0" encoding="utf-8" ?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="xml" />
<xsl:param name="max_items"></xsl:param>
<xsl:param name="show_numbers"></xsl:param>
<xsl:param name="start_index"></xsl:param>
<xsl:param name="item_number"></xsl:param>

<xsl:template match="channel">
	<table width="93%"  border="0" cellpadding="0" cellspacing="4" id="news_table" sytle="visibility:hidden;">
		<xsl:for-each select="item[position()-$start_index &lt;= $max_items and position() &gt; $start_index]">
		<tr>
			<td id="item{position()}">
			<xsl:if test="$show_numbers">
				<span class="nbr"><xsl:if test="position()+$start_index &lt; 10">0</xsl:if><xsl:value-of select="position()+$start_index" />.</span>
			</xsl:if>
				<a href="{link}" onclick="onItemClick('{link}')" onmouseover="itemMouseOver({position()})" onmouseout="itemMouseOut({position()})"><xsl:value-of select="title" /></a>
			</td>
		</tr>
		</xsl:for-each>
	</table>
</xsl:template>
</xsl:stylesheet>
