var MAX_TITLE_LENGTH = 250;
var MAX_ITEM = 15;
var show_numbers = true;
var show_desc    = true;
var resize_title = true;
var start_index = 0;
var next_items = 0;
var items_number = 0;
var last_desc_item = -1;
var descPopUp  = null;
var news_channel = '';
var rss = null;
var xml = null;
var newsfeed = null;
var load_delay = 400;
var showdescTimeout = 0;
var hidedescTimeout = 0;
/* Scroller variables */
var scrollTimeout = 0;
var defaultScrollDelay = 100;
var accelCoefficient  = 0.85;
var accelLimit = 1;
var scrolledItems = 0;
var scrollDelay = defaultScrollDelay;
var autoScroll = false;
var run_once = false;


function getItemNumber(){

	docElements = newsfeed.documentElement;
	var items = docElements.getElementsByTagName('item');
	
	if (items != null){
		return items.length;
	}
	
	return 0;
}

function getLongestTitle(){
	docElements = newsfeed.documentElement;
	var itemTitles = docElements.getElementsByTagName('item/title');
	var longestTitle = '';
	
	for(i = 0; i< itemTitles.length;  i++){
		temp = itemTitles[i].firstChild.data;
		if (longestTitle.length < temp.length) longestTitle = temp;
	}
	
	return longestTitle;
}

function preloadImages(){
	docElements = newsfeed.documentElement;
	var itemImages = docElements.getElementsByTagName('item/image');
	var imgList = new Array();

	for(i = 0; i< itemImages.length;  i++){
		imgList[i] = new Image();
		imgList[i].src = itemImages[i].firstChild.data;
	}
}

function onItemClick(url){
	doNavigate(url);
}

function closeNewsDetail(){
	if (descPopUp != null && descPopUp.isOpen)
	descPopUp.hide();
}


//var e=event.srcElement; while(e != null && e.tagName != ' + "'A'" + '){e = e.parentElement} if (e != null) document.parentWindow.top.document.all[' + "'po2padata'" + '].value=e.href;  document.parentWindow.top.document.popnav.onclick();  document.parentWindow.top.document.getElementById("newsDetailClose").onclick()
function showNewsDesc(index){
	
	showdescTimeout = 0;
	itemIndex = start_index + index;
	if (itemIndex <= items_number){
		docElements = newsfeed.documentElement;
		description = docElements.getElementsByTagName('item/description')[itemIndex-1].firstChild.data;

		if (description != '' && (itemIndex != last_desc_item || descPopUp == null || !descPopUp.isOpen)){
			newsDesc.innerHTML = description;
			last_desc_item = itemIndex;

			newsDetailLink.href = docElements.getElementsByTagName('item/link')[itemIndex-1].firstChild.data;

		var content = '';
		
			descPopUp = window.createPopup();
			var objDocument = descPopUp.document;

		        var oPopBody = descPopUp.document.body;
			oPopBody.style.overflow= "hidden";
		        oPopBody.style.border = "solid gray 1px";
		        oPopBody.style.cursor = "pointer";
		        oPopBody.style.margin = "0px";
		        oPopBody.style.filter = "progid:DXImageTransform.Microsoft.Gradient(startColorStr= #EEEEF3, endColorStr=#CECFDC, gradientType=0";			

			content += '<script>';
			content += 'function navigateNews(){';
			content += 'var e=event.srcElement; while(e != null && e.tagName != ' + "'A'" + '){e = e.parentElement} if (e != null) document.parentWindow.top.document.all[' + "'po2padata'" + '].value=e.href;   popnav.onclick(); newsDetailClose.onclick();';
			content += '}';
			content += '</script>';			
			content += '<body class="menu" style="overflow: hidden; border: solid 1px gray; cursor: pointer; margin: 0px; filter: progid:DXImageTransform.Microsoft.Gradient(startColorStr= #EEEEF3, endColorStr=#CECFDC, gradientType=' + "'0'" + ');" ';
			content += ' onclick="navigateNews()" ';
			content += ' >' ;
 

			content += '<div>' ;
			content += '<table cellpadding=3 cellspacing=0>' ;
			content += '<tr><td valign=middle>' ;
			content += newsDescFrame.outerHTML ;
			content += '</td></tr></table>' ;
			content += '</div>' ;


			oPopBody.innerHTML=  content ;
			
			for (var i = 0; i < oPopBody.all.length; i++) {
			  if (oPopBody.all[i].tagName == "DIV" || oPopBody.all[i].tagName == "IMG")
			     oPopBody.all[i].onclick = doClick;
			}
			

			objDocument.all["newsDetailClose"].onclick = closeNewsDetail;
			objDocument.all["popnav"].onclick = doPopNav;

			var origin = document.all["item"+index];
			var x = mainBox.offsetLeft;
			var y = origin.offsetTop + origin.offsetHeight;
			var ofsParent = origin.offsetParent;
			while (ofsParent != null)
			{
				x += ofsParent.offsetLeft;
				y += ofsParent.offsetTop;
				ofsParent = ofsParent.offsetParent;
			}
			x -= new Number(newsDescFrame.offsetWidth);
			descPopUp.show( x-11, y, newsDescFrame.offsetWidth, newsDescFrame.offsetHeight, document.body);
		}else{
			closeNewsDetail();
		}
	}
}

function doClick() {
p2bdata.value = '<webbox-command>navigate-url</webbox-command><url>' + newsDetailLink.href + '</url>';
window.location = 'res://webbox.dll/?command=webbox';
return false;
}



function doPopNav(){
  p2bdata.value = '<webbox-command>navigate-url</webbox-command><url>' + po2padata.value + '</url>';
  window.location = 'res://webbox.dll/?command=webbox';
}


function itemMouseOver(index){
	
	if (showdescTimeout == 0){
		if (descPopUp == null || !descPopUp.isOpen){
			showdescTimeout = window.setTimeout( "showNewsDesc( " + index + " )", 500 );
		}else{
			showNewsDesc(index);
		}
	}
	
	
}

function itemMouseOut(){
	if (showdescTimeout != 0){
		window.clearTimeout(showdescTimeout);
		showdescTimeout = 0;
	}
}

function createThumbNail(imageSrc){
	
	var objImage = new Image();
	objImage.src = imageSrc;
	
	var width  = objImage.width;
	var height = objImage.height;
	
	var x_ratio = IMG_MAX_WIDTH / width;
	var y_ratio = IMG_MAX_HEIGHT / height;
	
	var tn_width;
	var tn_height;
	
	if( (width <= IMG_MAX_WIDTH) && (height <= IMG_MAX_HEIGHT) )
	{
		tn_width = width;
		tn_height = height;
	}
	else if ((x_ratio * height) < IMG_MAX_HEIGHT)
	{
		tn_height = Math.ceil(x_ratio * height);
		tn_width = IMG_MAX_WIDTH;
	}
	else
	{
		tn_width = Math.ceil(y_ratio * width);
		tn_height = IMG_MAX_HEIGHT;
	}
	
	objImage.width  = tn_width;
	objImage.height = tn_height;
	
	return objImage;
}

function doLoad(){
	p2bdata.value = '<webbox-command>load-rssnews</webbox-command>';
	window.location = 'res://webbox.dll/?command=webbox';
}

function dob2pcall(){
	xml = b2pdata.value;
	rss = xml;
	cmd = PullTag('webbox-command');
	if (cmd == 'load-rssnews'){
		news_channel = PullTag('selected-item');
		if (news_channel == '') news_channel = 'News Channel';
		setTimeout('displayItems()',load_delay);
	}
}

function getStringMetric(str){

	var rule_holder = document.getElementById('rule_holder');
	rule_holder.innerText = str;

	var metric = document.getElementById('string_rule');

	return metric.clientWidth;
}

function resizeString(str){

	while(getStringMetric(str) > MAX_TITLE_LENGTH){
		tokens = str.split(' ');
		if (tokens[tokens.length-1] == '...') tokens.pop();
		if (tokens.length > 1){
			tokens.pop();
			str = tokens.join(' ')+'...';
		}else if(tokens.length = 1){
			str = tokens[0].substr(0,tokens[0].length-3)+' ...';
		}
	}
	return str;
}

function closeDesc(){
	if (descPopUp != null && descPopUp.isOpen) descPopUp.hide();
}

function displayItems(){
	buildXmlFeed();
	modified_string = news_channel ;
	
	hl_channel_title.innerHTML = modified_string.replace('è','');
	fadeIn('hl_channel_title',0,99.99,5);
	renderItems(true);

}

function getParam(paramName) {
	var query = '';

	if (window.location.protocol == 'http:') query = window.location.search.substring(1);
	else if (window.location.protocol == 'file:') query = window.location.hash.substring(1);
	else return '';

	var parms = query.split('&');
	for (var i=0; i<parms.length; i++) {
		var pos = parms[i].indexOf('=');
		if (pos > 0) {
			var key = parms[i].substring(0,pos);
			var val = parms[i].substring(pos+1);
			if (paramName == key) return val;
		}
	}

	return '';
}



function renderItems(fadein){
	if (newsfeed.parseError.errorCode == 0){
		next_items = items_number-MAX_ITEM-start_index;
		var xslt = new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
		xslt.async = false;
		xslt.load("rss.xsl");
		
		xslTemp = new ActiveXObject("MSXML2.XSLTemplate");
		xslTemp.stylesheet = xslt;
		xslProc = xslTemp.createProcessor();
		xslProc.input = newsfeed;
		xslProc.addParameter('max_items',MAX_ITEM);
		xslProc.addParameter('show_numbers',show_numbers);
		xslProc.addParameter('start_index',start_index);
		xslProc.addParameter('item_number',items_number);
		xslProc.transform;
		news_panel.style.visibility = 'hidden';
		news_panel.innerHTML = xslProc.output;
		if (fadein) fadeIn('news_table',0,99.99,5);
		else news_table.style.visibility = 'visible';
		renderScrollers();
	}else{
	}
}

function scrollItems(step){
	if ((start_index+step < (items_number-MAX_ITEM+1))&&(start_index+step >= 0 )){
		start_index+=step;
		renderItems(false);
		if (autoScroll){
			scrolledItems++;
			if (scrolledItems > accelLimit) scrollDelay*= accelCoefficient;
			scrollTimeout = window.setTimeout("scrollItems("+step+")", scrollDelay);
		}
	}else{
		autoScroll    = false;
		scrolledItems = 0;
		scrollDelay   = defaultScrollDelay;
	}
}

function scrollPressed(step){
	autoScroll = true;
	scrollTimeout = window.setTimeout("scrollItems("+step+")",scrollDelay);
}

function scrollReleased(){
	autoScroll    = false;
	scrolledItems = 0;
	scrollDelay   = defaultScrollDelay;
	if (scrollTimeout != 0){
		window.clearTimeout(scrollTimeout);
		scrollTimeout = 0;
	}
}

function renderScrollers(){
		next_counter.innerHTML = next_items;
		previous_counter.innerHTML = start_index;
		
		next_scroller.style.visibility = (next_items>0)?'visible':'hidden';
		previous_scroller.style.visibility = (start_index>0)?'visible':'hidden';
}

function stripCDATA(tagValue){
return tagValue.replace('<![CDATA[','').replace(']]>','');

}



function buildXmlFeed(){
	
	CountItems();
	newsfeed = new ActiveXObject("Microsoft.XMLDOM");
	newsfeed.async = false;
	newsfeed.loadXML( "<channel></channel>" );

	for(i=0;i<ItCo;i++){
		var it = GetItem(i);
		var item  = newsfeed.createElement( "item" );
		var title = newsfeed.createElement( "title" );
		var t = (resize_title)?resizeString(PeekTag(it, 'title')):PeekTag(it, 'title');
		title.appendChild(newsfeed.createCDATASection(t));
		var link  = newsfeed.createElement( "link" );
		link.appendChild(newsfeed.createCDATASection(stripCDATA(PeekTag(it, 'link'))));
		var description  = newsfeed.createElement( "description" );
		description.appendChild(newsfeed.createCDATASection(stripCDATA(PeekTag(it, 'description'))));
		
		item.appendChild(title);
		item.appendChild(link);
		item.appendChild(description);
		newsfeed.documentElement.appendChild(item);
		items_number = getItemNumber();
	}
}

function TakeCData(aXml)
{
	var begin, end, Key, R;
	
	if(aXml.length>1)
	{
		Key = '<![CDATA[';
		begin = aXml.indexOf(Key);
		if (begin<0) return(aXml);
		R = aXml.substring(0, begin-1);
		begin = begin + Key.length;
		Key = ']]>';
		end=aXml.indexOf(Key, begin);
		if (end==(-1)) end=aXml.length;
		R = R + aXml.substring(begin, end);
		end = end + Key.length;
		R = R + aXml.substring(end, aXml.length);
		return(R);
	}
	else return("");
}



function PullTag(aTag)
{
	var begin, end, Key;
	
	if(xml.length>1)
	{
		Key = '<' + aTag + '>';
		begin = xml.indexOf(Key);
		if (begin<0) return("");
		begin = begin + Key.length;
		Key = '</' + aTag + '>';
		end=xml.indexOf(Key, begin);
		if (end==(-1)) end=xml.length;
		Key = xml.substring(begin, end);
		xml = xml.substring(0, begin-aTag.length-2) + xml.substring(end+aTag.length+3);
		return(Key);
	}
	else return("");
}



function PeekTag(aXml, aTag)
{
	var begin, end, Key;
	
	if(aXml.length>1)
	{
		Key = '<' + aTag + '>';
		begin = aXml.indexOf(Key);
		if (begin<0) return("");
		begin = begin + Key.length;
		Key = '</' + aTag + '>';
		end=aXml.indexOf(Key, begin);
		if (end==(-1)) end=aXml.length;
		Key = aXml.substring(begin, end);
		//    aXml = aXml.substring(0, begin-aTag.length-2) + aXml.substring(end+aTag.length+3);
		return(Key);
	}
	else return("");
}

function CountItems()
{
	xml = rss;
	ItCo = 0;
	var t = '';
	while (xml > '')
	{
		t = PullTag('item');
		if (t > '')
			ItCo = ItCo + 1;
		else
			return;
	}
}

function GetItem(aIdx)
{
	xml = rss;
	var i = 0;
	var R = '';
	while (xml > '')
	{
		R = PullTag('item');
		if (i == aIdx)
			return R;
		i = i + 1;
		if (i > ItCo)
			return '';
	}
}



function findElement( parent, id )
{
	var children = parent.children;
	var i;
	for (i = 0; i < children.length && children[i].id != id; i++);
	if (i < children.length)
		return children[i]
	else
		return null;
}


function getParentElement( element, tagName )
{
	if (element.tagName != tagName)
		if (element.parentElement != null)
			return getParentElement( element.parentElement, tagName )
	else
		return null
	else
		return element;
}

