var fade_timer = null;
var xml  = null;
var _GET = new Array();
initParamArray();
var TOOLBAR_NAME = _GET['toolbarname'];

function initParamArray(){
	
	query = '';
	
	if (window.location.protocol == 'http:') query = window.location.search.substring(1);
	else if (window.location.protocol == 'file:') query = window.location.hash.substring(1);
	else return '';
	
	var parms = query.split('&');
	for (var i=0; i<parms.length; i++) {
		var pos = parms[i].indexOf('=');
		if (pos > 0) {
			var key = parms[i].substring(0,pos);
			var val = parms[i].substring(pos+1);
			_GET[key] = unescape(val);
		}
	}
}

function loadFeed(feed,wait){
	xml = new ActiveXObject("Microsoft.XMLDOM");
	xml.async = true;
	xml.onreadystatechange = wait;
	xml.load(feed);
}

function transformXml(style){

	if (xml.parseError.errorCode == 0){
		xslt = new ActiveXObject("MSXML2.FreeThreadedDOMDocument");
		xslt.async = false;
		xslt.load(style);
		
		xslTemp = new ActiveXObject("MSXML2.XSLTemplate");
		xslTemp.stylesheet = xslt;
		xslProc = xslTemp.createProcessor();
		xslProc.input = xml;
		xslProc.transform;
		
		return xslProc.output;
	}
	
	return '';
}

function doNavigate(aUrl){
	p2bdata.value = '<webbox-command>navigate-url</webbox-command><url>' + aUrl + '</url>';
	window.location = 'res://webbox.dll/?command=webbox';
}

function resizeMenu(width,height){
	p2bdata.value = '<webbox-command>resize-window</webbox-command><width>'+width+'</width><height>'+height+'</height>';
	window.location = 'res://webbox.dll/?command=webbox';
}

function getPageDimension(){
	main_box = document.getElementById('mainBox');
	dimension = new Array();
	
	dimension['width'] = main_box.clientWidth;
	dimension['height'] = main_box.clientHeight;
	
	return dimension;
}

function fadeIn(id, startfade, endfade,sp){
	clearTimeout(fade_timer);
	if (sp == null) sp = 5;
	fadetimer = 0;
	for (i = startfade; i <= endfade; i++){
		fade_timer = setTimeout("setOpacity('" + id + "'," + i + ")", (fadetimer * sp));
		fadetimer++;
	}
}

function hide(id){
	document.getElementById(id).style.visibility = "hidden";
}

function setOpacity(id,opacity){
	el = (typeof id == "string")? document.getElementById(id) : id;
	el.style.opacity = (opacity / 100);
	el.style.MozOpacity = (opacity / 100);
	el.style.KhtmlOpacity = (opacity / 100);
	el.style.filter = "alpha(opacity=" + opacity + ")";
	el.style.visibility = "visible";
}

function displayWeather(){
	hide('loading_div');
	fadeIn('forecast_panel', '0', '99.99');
}

function displayError(){
	alert('Error Loading Weather Data');
}

function weatherWait(){
	if (xml.readyState == 4){
		if (xml.xml != ''){
			fillWeather();
			resizeMenu(dimension['width'],dimension['height']);
			displayWeather();
		}else{
			displayError();
		}
	}
}

function fillWeather(){
	lg = ((_GET['lg'] != 'en')&&(_GET['lg'] != 'fr'))?'EN':_GET['lg'].toUpperCase();
	weatherData = xml.documentElement;
	
	city = weatherData.getElementsByTagName('SITE/@NAME_'+lg)[0].firstChild.nodeValue;
	prov = (weatherData.getElementsByTagName('SITE/@PROV')[0].firstChild !=null)?weatherData.getElementsByTagName('SITE/@PROV')[0].firstChild.nodeValue:'';
	country = weatherData.getElementsByTagName('SITE/@COUNTRY_'+lg)[0].firstChild.nodeValue;
	date = weatherData.getElementsByTagName('SITE/@DATE_'+lg)[0].firstChild.nodeValue;
	
	caption_header.innerHTML = city+', '+((prov != '')?prov+', ':'')+country+' '+date;
	
	forecats_img_1.src = 'images/ico_weathersmall/'+weatherData.getElementsByTagName('SITE/PERIOD/@ICON')[0].firstChild.nodeValue.toUpperCase()+'.gif';
	forecats_img_2.src = 'images/ico_weathersmall/'+weatherData.getElementsByTagName('SITE/PERIOD/@ICON')[1].firstChild.nodeValue.toUpperCase()+'.gif';
	forecats_img_3.src = 'images/ico_weathersmall/'+weatherData.getElementsByTagName('SITE/PERIOD/@ICON')[2].firstChild.nodeValue.toUpperCase()+'.gif';
	
	caption_period_1.innerHTML = weatherData.getElementsByTagName('SITE/PERIOD/@LABEL_'+lg)[0].firstChild.nodeValue;
	caption_period_2.innerHTML = weatherData.getElementsByTagName('SITE/PERIOD/@LABEL_'+lg)[1].firstChild.nodeValue;
	caption_period_3.innerHTML = weatherData.getElementsByTagName('SITE/PERIOD/@LABEL_'+lg)[2].firstChild.nodeValue;
	
	if ((weatherData.getElementsByTagName('SITE/PERIOD/@HIGH_TEMP_C').length != 0)){
		caption_temp_1.innerHTML = '<span class="temp"><strong>'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_F')[0].firstChild.nodeValue+'&deg;F / </strong></span><strong><span class="temp2">'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_C')[0].firstChild.nodeValue+'&deg;C</span></strong>';

		caption_temp_2.innerHTML = '<span class="temp"><strong>'+weatherData.getElementsByTagName('SITE/PERIOD/@LOW_TEMP_F')[0].firstChild.nodeValue+'-'+weatherData.getElementsByTagName('SITE/PERIOD/@HIGH_TEMP_F')[0].firstChild.nodeValue+'&deg;F</strong></span><br>';
		caption_temp_2.innerHTML+= '<strong><span class="temp2">'+weatherData.getElementsByTagName('SITE/PERIOD/@LOW_TEMP_C')[0].firstChild.nodeValue+'-'+weatherData.getElementsByTagName('SITE/PERIOD/@HIGH_TEMP_C')[0].firstChild.nodeValue+'&deg;C</span></strong>';

		caption_temp_3.innerHTML = '<span class="temp"><strong>'+weatherData.getElementsByTagName('SITE/PERIOD/@LOW_TEMP_F')[1].firstChild.nodeValue+'-'+weatherData.getElementsByTagName('SITE/PERIOD/@HIGH_TEMP_F')[1].firstChild.nodeValue+'&deg;F</strong></span><br>';
		caption_temp_3.innerHTML+= '<strong><span class="temp2">'+weatherData.getElementsByTagName('SITE/PERIOD/@LOW_TEMP_C')[1].firstChild.nodeValue+'-'+weatherData.getElementsByTagName('SITE/PERIOD/@HIGH_TEMP_C')[1].firstChild.nodeValue+'&deg;C</span></strong>';
	}else{
		caption_temp_1.innerHTML = '<span class="temp"><strong>'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_F')[0].firstChild.nodeValue+'&deg;F / </strong></span><strong><span class="temp2">'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_C')[0].firstChild.nodeValue+'&deg;C</span></strong>';
		caption_temp_2.innerHTML = '<span class="temp"><strong>'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_F')[1].firstChild.nodeValue+'&deg;F / </strong></span><strong><span class="temp2">'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_C')[1].firstChild.nodeValue+'&deg;C</span></strong>';
		caption_temp_2.innerHTML = '<span class="temp"><strong>'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_F')[2].firstChild.nodeValue+'&deg;F / </strong></span><strong><span class="temp2">'+weatherData.getElementsByTagName('SITE/PERIOD/@TEMPERATURE_C')[2].firstChild.nodeValue+'&deg;C</span></strong>';
	}
	
	caption_forecast_1.innerHTML = weatherData.getElementsByTagName('SITE/PERIOD/@FORECAST_TEXT_'+lg)[0].firstChild.nodeValue;
	caption_forecast_2.innerHTML = weatherData.getElementsByTagName('SITE/PERIOD/@FORECAST_TEXT_'+lg)[1].firstChild.nodeValue;
	caption_forecast_3.innerHTML = weatherData.getElementsByTagName('SITE/PERIOD/@FORECAST_TEXT_'+lg)[2].firstChild.nodeValue;
	
	if (lg =='FR'){
		img_more_forcast.src = 'images/btn_moreforecastFR.gif';
		img_more_forcast.alt = 'plus de details...';
	}
}
